package net.sf.buildbox.util.exec;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import org.codehaus.plexus.util.cli.shell.Shell;

/**
 * This dummy shell causes that commands are called *without* any enclosing shell.
 * Tested only on Linux.
 * The reason for using it is that java is unable to cleanly stop complete process tree; so, when a command is invoked via a shell which is the {@link org.codehaus.plexus.util.cli.Commandline}'s default,
 * then there is no way to stop it - only the shell gets cancelled by {@link Process#destroy()} but not the command itself.
 * This workarround does not help in killing subprocesses of the command anyway. 
 */
public class StraightDummyShell extends Shell {
    public List<String> getCommandLine(String executable, String[] arguments) {
        final List<String> result = new ArrayList<String>();
        result.add(executable);
        result.addAll(Arrays.asList(arguments));
        return result;
    }
}
